import org.apache.activemq.ActiveMQConnectionFactory
import org.apache.activemq.broker.TransportConnector
import org.apache.activemq.command.ActiveMQQueue
import org.apache.activemq.xbean.XBeanBrokerService

import org.springframework.jms.core.JmsTemplate
import org.springframework.jms.connection.SingleConnectionFactory
import org.springframework.jms.listener.DefaultMessageListenerContainer

beans = {

	jmsBroker(XBeanBrokerService) {
		useJmx = 'false'
		persistent = 'false'
		transportConnectors = [new TransportConnector(uri: new URI('tcp://localhost:0'))]
	}
	
	jmsFactory(ActiveMQConnectionFactory) {
		brokerURL = 'vm://localhost'
	}

	notificationQueue(ActiveMQQueue, 'queue.notification')

	jmsTemplate(JmsTemplate) {
		connectionFactory =  { SingleConnectionFactory cf ->
			targetConnectionFactory = ref('jmsFactory')
		}
	}

	jmsContainer(DefaultMessageListenerContainer) {
		connectionFactory = ref('jmsFactory')
		destination = ref('notificationQueue')
		messageListener = new NotificationQueueListener()
	}
}
